﻿@page "/teamSeasons/create"
@page "/teamSeasons/edit/{Id:int}"

@using Models.TeamData
@using Models.SeasonData
@using Business.Repository.IRepository
@inject NavigationManager NavigationManager
@inject IJSRuntime JsRuntime
@inject ITeamSeasonRepository TeamSeasonRepository
@inject ISeasonRepository SeasonRepository
@inject ITeamRepository TeamRepository
@inject Blazored.LocalStorage.ILocalStorageService localStorage

<div class="row mt-2 mb-5">
    <h3 class="card-title text-info mb-3 ml-3">@Title Team-Season</h3>
    <div class="col-md-12">
        <div class="card">
            <div class="card-body">
                <EditForm Model="@TeamSeasonModel" OnValidSubmit="HandleCreateUpdate">
                    <DataAnnotationsValidator />
                    @*<ValidationSummary />*@
                    <div class="form-group">
                        <label>Season</label>
                        <InputText @bind-Value="currentSeason" class="form-control" disabled="true"></InputText>
                    </div>
                    <div class="form-group">
                        <label>Team</label>
                        <select class="form-select" @bind="selectedTeamId">
                            <option value="-1">--select--</option>
                            @foreach (var item in Teams)
                            {
                                <option class="p-3" value="@item.Id">@item.Name</option>
                            }
                        </select>
                    </div>
                    <div class="form-group mt-3">
                        <button class="btn btn-primary">@Title Team</button>
                        <NavLink href="teamSeasons" class="btn btn-secondary">Back to Index</NavLink>
                    </div>
                </EditForm>
            </div>
        </div>
    </div>
</div>

@code {

    [Parameter]
    public int? Id { get; set; }
    private TeamSeasonDTO TeamSeasonModel { get; set; } = new TeamSeasonDTO();
    private IEnumerable<TeamDTO> Teams { get; set; } = new List<TeamDTO>();
    private int selectedTeamId { get; set; }
    private string Title { get; set; } = "Register";
    private string currentSport { get; set; }
    private string currentSeason { get; set; }
    private int currentSeasonId { get; set; }
    protected override async Task OnInitializedAsync()
    {
        //currentSport = await localStorage.GetItemAsync<string>("sportName");
        currentSeason = await localStorage.GetItemAsync<string>("seasonName");
        currentSeasonId = await localStorage.GetItemAsync<int>("seasonId");
        if (Id != null)
        {
            //update
            Title = "Update";
            TeamSeasonModel = await TeamSeasonRepository.Get(Id.Value);

        }
        else
        {
            //create
            TeamSeasonModel = new TeamSeasonDTO();
            //Teams = await TeamRepository.GetAllFromSport(await localStorage.GetItemAsync<int>("sportId"));
            Teams = await TeamRepository.GetAllAvailableTeamsForTeamSeason
                (currentSeasonId, await localStorage.GetItemAsync<int>("sportId"));
        }
    }
    private async Task HandleCreateUpdate()
    {
        try
        {
            // add check if teamSeason is unique
            // --
            // --
            if (TeamSeasonModel.Id != 0 && Title == "Update")
            {
                //update
                var updateTeamSeason = await TeamSeasonRepository.Update(TeamSeasonModel, TeamSeasonModel.Id);
                await JsRuntime.ToastrSuccess("TeamSeason updated successfully");
                await Task.Delay(300);
                NavigationManager.NavigateTo("/teamSeasons", true);

            }
            else
            {
                //create

                TeamSeasonModel.SeasonId = currentSeasonId;
                TeamSeasonModel.TeamId = selectedTeamId;
                var createdResult = await TeamSeasonRepository.Create(TeamSeasonModel);

                await JsRuntime.ToastrSuccess("TeamSeason created successfully");
                await Task.Delay(300);
                NavigationManager.NavigateTo("/teamSeasons", true);
            }
        }
        catch (Exception ex)
        {
            throw ex;
        }
    }
}